//+------------------------------------------------------------------+
//|                                                    Player5_1.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#include "Parser_Tester.mqh"
#include "Balance.mqh"
#include "Ruler.mqh" 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountTF=8;
ENUM_TIMEFRAMES TFarray[8]=
  {
   PERIOD_M1,
//PERIOD_M2,
//PERIOD_M3,
//PERIOD_M4,
   PERIOD_M5,
//PERIOD_M6,
   PERIOD_M10,
//PERIOD_M12,
   PERIOD_M15,
//PERIOD_M20,
   PERIOD_M30,
   PERIOD_H1,
   PERIOD_H2,
//PERIOD_H3,
   PERIOD_H4
//PERIOD_H6,
//PERIOD_H8
  };
//+------------------------------------------------------------------+
//| number of minutes in a bar of the specified timeframe            |
//+------------------------------------------------------------------+
int MinuteTF(ENUM_TIMEFRAMES tf){return(PeriodSeconds(tf)/60);}
//+------------------------------------------------------------------+
//| searching for TF index of the TFarray[] array                    |
//+------------------------------------------------------------------+
int SerchTF(ENUM_TIMEFRAMES period)
  {
   int i;
   for(i=0;i<CountTF;i++)
      if(TFarray[i]==period)break;
   if(i==CountTF)return(i-1);
   else return(i);
  }
//+------------------------------------------------------------------+
//| searching for a TF index that is less than the input one         |
//+------------------------------------------------------------------+
int SerchTFLess(ENUM_TIMEFRAMES period)
  {
   int i;
   if(TFarray[0]==period)return(0);
   for(i=1;i<CountTF;i++)
     {
      if(TFarray[i]==period)break;
      else
        {
         if(TFarray[i]>period && TFarray[i-1]<period)
           {
            i--;
            break;
           }
        }
     }
   if(i==CountTF)return(i-1);
   else return(i);
  }
//+------------------------------------------------------------------+
//| get time by bar                                                  |
//+------------------------------------------------------------------+  
datetime TimeBars(int bar,string symbol,ENUM_TIMEFRAMES period)
  {datetime temp[];CopyTime(symbol,period,bar,1,temp);return(temp[0]);};
//+------------------------------------------------------------------+
//| Transformation of coordinates. Upper left corner of binding      |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| time to X                                                        |
//+------------------------------------------------------------------+
/*int WindowGetX(long chart_id,datetime T)
  {
   datetime temp[]; int bar=(int)ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);
   CopyTime(ChartSymbol(chart_id),ChartPeriod(chart_id),bar,1,temp);
   double PS=(double)PeriodSeconds(ChartPeriod(chart_id));//IsStopped(__FUNCTION__);
   if(PS==0)return(-1);
   return((int)NormalizeDouble((T-temp[0])/PS*pow(2,ChartGetInteger(chart_id,CHART_SCALE)),0));
  }*/
//+------------------------------------------------------------------+
//| price to Y                                                       |
//+------------------------------------------------------------------+
int WindowGetY(long chart_id,double P)
  {
   double MiniMax=ChartGetDouble(chart_id,CHART_PRICE_MAX)-ChartGetDouble(chart_id,CHART_PRICE_MIN);
   if(MiniMax==0)return(-1);
   return((int)((ChartGetDouble(chart_id,CHART_PRICE_MAX)-P)*
          (ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS)/(MiniMax))));
  }
//+------------------------------------------------------------------+
//| X to time                                                        |
//+------------------------------------------------------------------+
/*datetime WindowGetTime(long chart_id,int X)
  {
   datetime temp[]; int bar=(int)ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);
   CopyTime(ChartSymbol(chart_id),ChartPeriod(chart_id),bar,1,temp);
   double PP=(double)pow(2,ChartGetInteger(chart_id,CHART_SCALE));
   if(PP)return(-1);
   return((datetime)((temp[0]+X/PP)*PeriodSeconds(ChartPeriod(chart_id))));
  }
//+------------------------------------------------------------------+
//| Y to price                                                       |
//+------------------------------------------------------------------+
double WindowGetPrice(long chart_id,int Y)
  {
   double MiniMax=ChartGetDouble(chart_id,CHART_PRICE_MAX)-ChartGetDouble(chart_id,CHART_PRICE_MIN);
   if(MiniMax==0)return(-1);
   long HP=ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS);
   if(HP==0)return(-1);
   return(ChartGetDouble(chart_id,CHART_PRICE_MAX)-Y/(HP/MiniMax));
  }*/
//+------------------------------------------------------------------+
//| Class for storing data of the player                             |
//+------------------------------------------------------------------+
class SBase
  {
public:
   bool              play;     // state of the player
   int               progress; // progress
   int               speed;    // speed
   bool              speed_var;// mode of speed controlling [speed/TF]
   datetime          time;     // 1 time
   datetime          time_bar; // time of a current bar
   bool              state;    // status of activity (visibility of controls)
   bool              new_bar;  // flag of new bar
   int               progress_count;// number of button in the progress object
   int               YDISTANCE;     // Y coordinate of the player interface
   long              tackt;         // clock generator
   int               per_size;      // length of a bar history for generation
   ENUM_TIMEFRAMES   period_gen;    // period of the tick generator
   bool              on_balance;    // state of the balance button, on/off
   bool              all_balance;   // state of the balance button all/sym
   bool              flag_data;     // flag of data availability
   int               win_ind;       // number of indicator subwindow

                     SBase()
     {
      play=0;progress=0;speed=1;time=0;time_bar=0;state=0;speed_var=0;new_bar=1;
      period_gen=1;progress_count=100;progress=0;tackt=0;per_size=0;
      on_balance=0;all_balance=0;YDISTANCE=17;flag_data=0;win_ind=-1;
     };
                    ~SBase(){};
   void              Copy(SBase *sor);
  };
//+------------------------------------------------------------------+
//| copying of the player stetting according to a template           |
//+------------------------------------------------------------------+
void SBase::Copy(SBase *sor)
  {
   play=sor.play;         // state of the player
   progress=sor.progress; // progress
   speed=sor.speed;       // speed
   time=sor.time;         // 1 time
   time_bar=sor.time_bar; // time of a current bar
   state=!sor.state;      // status of activity (visibility of controls)
   new_bar=sor.new_bar;   // flag of new bar    
   tackt=sor.tackt;       // 
   period_gen=sor.period_gen; // period of the tick generator
   speed_var=sor.speed_var;   // mode of speed controlling [speed/TF]
  }
//+------------------------------------------------------------------+
//| Class for storing data of a chart                                |
//+------------------------------------------------------------------+
class CChartData
  {
public:
   long              width_in_bars;      // Width of the chart in bars 
   long              width_in_pixels;    // Width of the chart in pixels 
   long              height_in_pixels;   // Hight of the chart in pixels
   long              first_visible_bar;  // Number of the first visible bar on the chart 
   double            pointer_per_bar;    // Value of scare in points per bar   

   color             bgcolor;         // Color of background of the chart
   color             fgcolor;         // Color of axes, scale and OHLC line
   color             bidcolor;        // Color of the Bid price line
   color             upcolor;         // Color of up bar, its shadow and border of a bullish candlestick
   color             downcolor;       // Color of down bar, shadow and border of a bearish line
   color             bearcolor;       // Color of body of a bearish candlestick
   color             bullcolor;       // Color of body of a bullish candlestick
   color             linecolor;       // Color of the chart line and the Doji candlesticks
   int               mode;            // Type of the chart (candlesticks, bars or line)
   int               scale;           // Scale, from 0 to 5
   bool              show_per_step;   // Displaying of vertical separators between adjacent periods
   bool              show_grid;       // Displaying of grid on the chart
   bool              chart_schift;    // Mode of shift of the price chart from the right border
   double            schift_size;     // Shift size of the zero bar from the right border in % (from 10 to 50)   
   ENUM_TIMEFRAMES   period;          // Period

                     CChartData()// Constructor
     {
      width_in_bars=0;      // Width of the chart in bars 
      width_in_pixels=0;    // Width of the chart in pixels 
      height_in_pixels=0;   // Height of the chart in pixels
      first_visible_bar=0;  // Number of the first visible bar on the chart 
      pointer_per_bar=0;    // Value of scale in points per bar   

      bgcolor=0;         // Color of background of the chart
      fgcolor=0;         // Color of axes, scale and OHLC line
      bidcolor=0;        // Color of the Bid-price line
      upcolor=0;         // Color of up bar, its shadow and border of body of a bullish candlestick
      downcolor=0;       // Color of down bar, its shadow and border of body of the bullish candlestick
      bearcolor=0;       // Color of body of a bearish candlestick
      bullcolor=0;       // Color of body of a bullish candlestick
      linecolor=0;       // Color of the chart line and the Doji candlesticks
      mode=0;            // Type of the chart (candlesticks, bars or line)
      scale=0;           // Scale, from 0 to 5
      show_per_step=0;   // Displaying of vertical separators between adjacent periods
      show_grid=0;       // Displaying of grid on the chart
      chart_schift=0;    // Mode of shift of the price chart from the right border
      schift_size=0;     // Shift size of the zero bar from the right border in % (from 10 to 50)   
      period=0;          // Period

     };
                    ~CChartData(){};// destructor
   //--- refresh the chart data
   void              Update(long chart_id);
   //--- copy the chart settings according to the template
   void              ApplyTemplate(long chart_id,CChartData *b);
  };
//+------------------------------------------------------------------+
//| refresh the chart data                                           |
//+------------------------------------------------------------------+
void  CChartData::Update(long chart_id)
  {
   while(!IsStopped())
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      if(width_in_bars!=0)break;
      Sleep(10);
     }

   width_in_pixels=ChartGetInteger(chart_id,CHART_WIDTH_IN_PIXELS);
   height_in_pixels=ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS);
   first_visible_bar=ChartGetInteger(chart_id,CHART_FIRST_VISIBLE_BAR);

   bgcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_BACKGROUND);
   fgcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_FOREGROUND);
   bidcolor =(color)ChartGetInteger(chart_id,CHART_COLOR_BID);
   upcolor  =(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_UP);
   downcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_DOWN);
   bullcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CANDLE_BULL);
   bearcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CANDLE_BEAR);
   linecolor=(color)ChartGetInteger(chart_id,CHART_COLOR_CHART_LINE);

   mode     =(int)ChartGetInteger(chart_id,CHART_MODE);
   scale    =(int)ChartGetInteger(chart_id,CHART_SCALE);
   pointer_per_bar=pow(2,scale);
   show_per_step=(bool)ChartGetInteger(chart_id,CHART_SHOW_PERIOD_SEP);
   show_grid    =(bool)ChartGetInteger(chart_id,CHART_SHOW_GRID);
   chart_schift =(bool)ChartGetInteger(chart_id,CHART_SHIFT);
   schift_size  =ChartGetDouble(chart_id,CHART_SHIFT_SIZE);

   period=ChartPeriod(chart_id);
  }
//+------------------------------------------------------------------+
//| copy the chart settings according to the template                |
//+------------------------------------------------------------------+
void CChartData::ApplyTemplate(long chart_id,CChartData *b)
  {
   Update(chart_id);
   while(!IsStopped())
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      if(width_in_bars!=0)break;
      Sleep(10);
     }
   if(bgcolor!=b.bgcolor){ChartSetInteger(chart_id,CHART_COLOR_BACKGROUND,b.bgcolor);}
   if(fgcolor!=b.fgcolor){ChartSetInteger(chart_id,CHART_COLOR_FOREGROUND,b.fgcolor);}
   if(bidcolor!=b.bidcolor){ChartSetInteger(chart_id,CHART_COLOR_BID,b.bidcolor);}
   if(upcolor!=b.upcolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_UP,b.upcolor);}
   if(downcolor!=b.downcolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_DOWN,b.downcolor);}
   if(bullcolor!=b.bullcolor){ChartSetInteger(chart_id,CHART_COLOR_CANDLE_BULL,b.bullcolor);}
   if(bearcolor!=b.bearcolor){ChartSetInteger(chart_id,CHART_COLOR_CANDLE_BEAR,b.bearcolor);}
   if(linecolor!=b.linecolor){ChartSetInteger(chart_id,CHART_COLOR_CHART_LINE,b.linecolor);}
   if(mode!=b.mode){ChartSetInteger(chart_id,CHART_MODE,b.mode);}
   if(scale!=b.scale){ChartSetInteger(chart_id,CHART_SCALE,b.scale);}
   if(show_per_step!=b.show_per_step){ChartSetInteger(chart_id,CHART_SHOW_PERIOD_SEP,b.show_per_step);}
   if(show_grid!=b.show_grid){ChartSetInteger(chart_id,CHART_SHOW_GRID,b.show_grid);}
   if(chart_schift!=b.chart_schift){ChartSetInteger(chart_id,CHART_SHIFT,b.chart_schift);}

   if(chart_schift)
     {
      width_in_bars=ChartGetInteger(chart_id,CHART_WIDTH_IN_BARS);
      schift_size=ChartGetDouble(chart_id,CHART_SHIFT_SIZE);
      double temp=b.width_in_bars*b.schift_size;
      if(fabs(width_in_bars*schift_size-temp)>=100.)
        {
         temp/=(double)width_in_bars;
         ChartSetDouble(chart_id,CHART_SHIFT_SIZE,temp);
        }
     }
   if(period!=b.period)
     {
      string symbol=ChartSymbol(chart_id);
      ChartSetSymbolPeriod(chart_id,symbol,b.period);
      Sleep(100);
     }
   Update(chart_id);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*///+**************************************************************+

 CArrayRuler
 CRuler;  
 CSpeed;  
 CProgress;  
 CPlay;  
 CClick;  
 CBackGround;  
 CBarDraw;  
 CHistoryDraw;
 
/*///+**************************************************************+                                                                                                                                                                                                      //#include <Arrays\ArrayLong.mqh>
//+------------------------------------------------------------------+
//| Class of the information line of a current TF                    |
//+------------------------------------------------------------------+
class CArrayRuler : public CArrayLong
  {
   SBase            *s;
public:
                     CArrayRuler(){};
                    ~CArrayRuler(){ArrayFree(m_data);};
   int               Create(SBase *base,string symbol,ENUM_TIMEFRAMES period,datetime beg,datetime end);
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
int CArrayRuler::Create(SBase *base,string symbol,ENUM_TIMEFRAMES period,datetime beg,datetime end)
  {
   s=base; // binding data to the player structure
   int count_area=Bars(symbol,period,beg,end);
//---if no information is downloaded  
   int ff=0;
   while(!IsStopped() && count_area<=0)// load data
     {
      s.flag_data=0;
      count_area=Bars(symbol,period,beg,end);
      if(count_area>0)break;
      Sleep(10);
      // if the time of getting of information exceed the 1 minute, stop working
      ff++; if(ff>6000){Print("__ No data for the symbol "+symbol);ExpertRemove(); break;}
     }
   ArrayFree(m_data); Shutdown();
   m_data_total=count_area;
   m_data_max=((m_data_total/m_step_resize)+1)*m_step_resize;
   m_sort_mode=0;
   CopyTime(symbol,period,end,count_area,m_data);
   s.flag_data=1;
   return(count_area);
  }
//+------------------------------------------------------------------+
//| Class of the information line of the generator period            |
//+------------------------------------------------------------------+                                                                                                                                                                                        //+******************************************************************+
class CRuler
  {
private:
   long              chart_id;
   int               count_area;
   string            name;
   SBase            *s;
   CChartData       *d;
   ENUM_TIMEFRAMES   period;
   long              PS;
   string            symbol;
   CArrayRuler      *array;
   datetime TimeBars(int bar){datetime temp[];CopyTime(symbol,period,bar,1,temp);return(temp[0]);};
public:   
   datetime          beg; // start of history
   datetime          end; // end of history
                          
                     CRuler(){array=new CArrayRuler();};
                    ~CRuler(){delete array;};
   void              Create(long Chart_id,
                            SBase *base,
                            CChartData *data,
                            datetime beg_,
                            datetime end_,
                            ENUM_TIMEFRAMES period_=PERIOD_CURRENT);
   bool              Update(ENUM_TIMEFRAMES period_);// update of information with the check whether they are actual
   int               Schift(){return(Bars(symbol,period,beg,TimeBars(0)));};
   int               Area(){return(count_area);};
   ENUM_TIMEFRAMES   Period(){return(period);};
   int               BarsByTime(datetime time);// get bar by time
   datetime          TimeByBars(int bar);      // get time by bar
   datetime          CastToCurr(datetime time);// casting of time to a current period 
   datetime          NextTime(datetime time);// time of a next bar
   datetime          PrevTime(datetime time);// time of a previous bar
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CRuler::Create(long Chart_id,
                    SBase *base,
                    CChartData *data,
                    datetime beg_,
                    datetime end_,
                    ENUM_TIMEFRAMES period_=PERIOD_CURRENT)
  {
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   symbol=ChartSymbol(chart_id);// save symbol
   if(period_!=PERIOD_CURRENT)period=period_;// if the passed period is not 0
   else period=ChartPeriod(chart_id);// otherwise load the chart period
   PS=PeriodSeconds(period);
   beg=beg_; end=end_;// memorize the start and the end of period of testing

   count_area=array.Create(GetPointer(base),symbol,period,beg,end);

  }
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
bool CRuler::Update(ENUM_TIMEFRAMES period_)
  {
   if(period!=period_)// if the chart period has changed 
     {
      // create new object
      Create(chart_id,GetPointer(s),GetPointer(d),beg,end,period_);
      PS=PeriodSeconds(period);
      return(true);
     }
   else return(false);
  }
//+------------------------------------------------------------------+
//| get bar by time                                                  |
//+------------------------------------------------------------------+
int CRuler::BarsByTime(datetime time)
  {
   int res=0;
   if(time<=beg)return(0);
   if(time>=end)return(count_area-1);
   if((long)time!=array.At(res))res=array.SearchLessOrEqual((long)time);
   if(res==-1)res=BarsByTime(time-PS);
   return(res);
  }
//+------------------------------------------------------------------+
//| get time by bar                                                  |
//+------------------------------------------------------------------+
datetime CRuler::TimeByBars(int bar)
  {
   if(bar<0)return((datetime)array.At(0));
   if(bar>count_area-1)return((datetime)array.At(count_area-1));
   return((datetime)array.At(bar));
  }
//+------------------------------------------------------------------+
//| casting time to the current period                               |
//+------------------------------------------------------------------+  
datetime CRuler::CastToCurr(datetime time)
  {
   return(TimeByBars(BarsByTime(time)));
  }
//+------------------------------------------------------------------+
//| time of a next bar                                               |
//+------------------------------------------------------------------+
datetime CRuler::NextTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)+1));
  }
//+------------------------------------------------------------------+
//| time of previous bar                                             |
//+------------------------------------------------------------------+
datetime CRuler::PrevTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)-1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CSpeed
  {
private:
   long              chart_id;
   string            name_left;
   string            name_right;
   string            name_var;
   string            name_bg;
   int               distance;
   SBase            *s;
   CChartData       *d;
   bool              state;
   uint              pause_time;
   int               speed_limit;
public:
                     CSpeed(){state=0;distance=21;pause_time=0;};
                    ~CSpeed()
     {
      ObjectDelete(chart_id,name_left);
      ObjectDelete(chart_id,name_right);
      ObjectDelete(chart_id,name_var);
      ObjectDelete(chart_id,name_bg);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data,int speed_limit_);
   void              Update();
   void              Event_left();// event of decreasing of speed   
   void              Event_right();// event of increasing of speed
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CSpeed::Create(long Chart_id,SBase *base,CChartData *data,int speed_limit_)
  {
   chart_id=Chart_id;
   speed_limit=speed_limit_;// number of speeds
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure   
   
   name_bg="  "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_bg)<0)// if there is no object yet
     {//--- try to create the object 
      string BGP="Images_Player\\BackGroundPlayer.bmp";
      if(ObjectCreate(chart_id,name_bg,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_bg,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties         
         ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_YDISTANCE,s.YDISTANCE-3);
         //--- load the image       
         ObjectSetString(chart_id,name_bg,OBJPROP_BMPFILE,0,BGP);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_bg+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   name_right="the Speed right button "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_right)<0)// if there's no object yet
     {//--- try to create the object         
      string play="Images_Player\\Speed_y.bmp";
      string pause="Images_Player\\Speed_n.bmp";
      if(ObjectCreate(chart_id,name_right,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_right,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_right,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties
         ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_right,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         //--- load an image for the "pressed" state of the button         
         ObjectSetString(chart_id,name_right,OBJPROP_BMPFILE,1,play);
         //--- load an image for the the "unpressed" state of the button
         ObjectSetString(chart_id,name_right,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_right+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   name_left="the Speed left button "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_left)<0)// if there's not object yet
     {//--- try to create the object         
      string play="Images_Player\\y_Speed.bmp";
      string pause="Images_Player\\n_Speed.bmp";
      if(ObjectCreate(chart_id,name_left,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_left,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_left,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties
         ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_left,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         //--- load an image for the "pressed" state of the button         
         ObjectSetString(chart_id,name_left,OBJPROP_BMPFILE,1,play);
         //--- load an image for the the "unpressed" state of the button
         ObjectSetString(chart_id,name_left,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_left+". Error code ",GetLastError());
         ResetLastError();
        }
     }

   name_var="the mode button"+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_var)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_var,OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_var,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_var,OBJPROP_STATE,false);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_var,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_var,OBJPROP_YDISTANCE,s.YDISTANCE+1);
         ObjectSetInteger(chart_id,name_var,OBJPROP_XSIZE,distance-2);
         ObjectSetInteger(chart_id,name_var,OBJPROP_YSIZE,s.YDISTANCE);
         ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,10);
         ObjectSetString(chart_id,name_var,OBJPROP_FONT,"Arial Narrow");
         ObjectSetInteger(chart_id,name_var,OBJPROP_COLOR,Black);
         ObjectSetInteger(chart_id,name_var,OBJPROP_BGCOLOR,(long)C'208,211,219');
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_var+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   Update();
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CSpeed::Update()
  {
   Event_right(); Event_left();// check user actions

   if(s.speed<1)s.speed=1;
   if(s.speed>=speed_limit)s.speed=speed_limit-1;// limit the range of values of speed
   string Text;
   if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
     {
      Text=EnumToString(s.period_gen);
      StringReplace(Text,"PERIOD_","");
      ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,7);
     }
   else
     {
      Text=s.speed<10?" "+(string)s.speed:(string)s.speed;
      ObjectSetInteger(chart_id,name_var,OBJPROP_FONTSIZE,10);
     }
   ObjectSetString(chart_id,name_var,OBJPROP_TEXT,Text);
//--- refresh displaying of speed (if required)

   long temp=d.width_in_pixels/2-33;// checking and setting the X position of the button

   ObjectSetInteger(chart_id,name_bg,OBJPROP_XDISTANCE,temp+42-1000);
   ObjectSetInteger(chart_id,name_right,OBJPROP_XDISTANCE,temp-distance*1);
   ObjectSetInteger(chart_id,name_var,OBJPROP_XDISTANCE,temp-distance*2);
   ObjectSetInteger(chart_id,name_left,OBJPROP_XDISTANCE,temp-distance*3);

   if(s.state)// checking the button state
     {
      ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,0);
      s.speed_var=ObjectGetInteger(chart_id,name_var,OBJPROP_STATE);
     }
   else // copying the state if the button is invisible
     {
      ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_right,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_var,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_left,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_var,OBJPROP_STATE,s.speed_var);
     }
  };
//+------------------------------------------------------------------+
//| event of decreasing of speed                                     |
//+------------------------------------------------------------------+
void CSpeed::Event_left()
  {
//--- if there is an event of pressing the button of speed decreasing         
   if((bool)ObjectGetInteger(chart_id,name_left,OBJPROP_STATE))
     {
      if(!state)// if the process is not busy
        {
         state=true; pause_time=GetTickCount();
         //--- if the mode of fast decreasing is selected
         if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
           {
            int temp=SerchTF(s.period_gen); // if it is possible to decrease TF
            if(temp>0)s.period_gen=TFarray[temp-1];
           }
         else s.speed--;// otherwise decrease by 1
        }
      else
        {// check the delay of visual displaying of pressing
         if(GetTickCount()-pause_time>40)
           {
            state=false; pause_time=0;
            ObjectSetInteger(chart_id,name_left,OBJPROP_STATE,false);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| event of increasing of speed                                     |
//+------------------------------------------------------------------+
void CSpeed::Event_right()
  {
//--- if there is an event of pressing the button of speed increasing
   if((bool)ObjectGetInteger(chart_id,name_right,OBJPROP_STATE))
     {
      if(!state)// if the process is not busy
        {
         state=true; pause_time=GetTickCount();
         //--- if the mode of fast increasing is selected
         if(ObjectGetInteger(chart_id,name_var,OBJPROP_STATE))
           {
            int temp=SerchTF(s.period_gen); // if it is possible to increase TF
            if(temp<CountTF-1)
              {
               if(MinuteTF(TFarray[temp+1])<=MinuteTF(d.period)/2)s.period_gen=TFarray[temp+1];
              }
           }
         else s.speed++;// otherwise increase by 1
        }
      else
        {// check the delay of visual displaying of pressing
         if(GetTickCount()-pause_time>40)
           {
            state=false; pause_time=0;
            ObjectSetInteger(chart_id,name_right,OBJPROP_STATE,false);
           }
        }
     }
  }
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class of navigation control                                      |
//+------------------------------------------------------------------+
class CProgress
  {
private:
   long              chart_id;
   string            name[];
   SBase            *s;
   CChartData       *d;
   void              CreateButton(int n,int size_button);
   int               Trigger();
public:
   bool              state[];
                     CProgress(){};
                    ~CProgress()
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectDelete(chart_id,name[i]);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data,int size_button_);
   void              Update();
   void              SetState(int i)
     {
      int j=i; if(j<0)j=0; if(j>=s.progress_count)j=s.progress_count-1;
      ObjectSetInteger(chart_id,name[j],OBJPROP_STATE,true);Trigger();
     };
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CProgress::Create(long Chart_id,SBase *base,CChartData *data,int size_button_)
  {
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   ArrayResize(name,(int)s.progress_count);
   ArrayResize(state,(int)s.progress_count);
   ArrayInitialize(state,false);
   for(int i=0;i<s.progress_count;i++)
      CreateButton(i,size_button_);
  }
//+------------------------------------------------------------------+
//| creation of progress buttons                                     |
//+------------------------------------------------------------------+
void CProgress::CreateButton(int i,int size_button)
  {
   int Psize_button=size_button/2;
   name[i]=" "+(i<10?" "+(string)i:(string)i)+" "+ChartSymbol(chart_id);

   if(ObjectFind(chart_id,name[i])<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name[i],OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name[i],OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name[i],OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties
         double k=(d.width_in_pixels/2-26.)/s.progress_count;
         ObjectSetInteger(chart_id,name[i],OBJPROP_XDISTANCE,(int)(i*k));
         ObjectSetInteger(chart_id,name[i],OBJPROP_XSIZE,12);
         ObjectSetInteger(chart_id,name[i],OBJPROP_YSIZE,size_button);
         ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Silver);

         if(i%2==0)
            ObjectSetInteger(chart_id,name[i],OBJPROP_YDISTANCE,s.YDISTANCE+22);
         else
            ObjectSetInteger(chart_id,name[i],OBJPROP_YDISTANCE,s.YDISTANCE+22+Psize_button);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name[i]+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CProgress::Update()
  {
   double k=(d.width_in_pixels/2-26.)/s.progress_count;
   for(int i=0;i<s.progress_count;i++)
     {
      int temp=(int)(i*k);
      ObjectSetInteger(chart_id,name[i],OBJPROP_XDISTANCE,temp);
     }
   if(s.state)// checking the button state
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,0);
      s.progress=Trigger();
     }
   else // copying the state if the button is invisible
     {
      for(int i=0;i<s.progress_count;i++)
         ObjectSetInteger(chart_id,name[i],OBJPROP_BACK,1);
      SetState(s.progress);
     }
  };
//+------------------------------------------------------------------+
//| trigger                                                          |
//+------------------------------------------------------------------+
int CProgress::Trigger()
  {
   int t=0,k=-1,pgc=s.progress_count;
   for(int i=0;i<pgc;i++)// search for a pressed button
     {
      if(IsStopped())break;
      if(ObjectGetInteger(chart_id,name[i],OBJPROP_STATE)==true)
        {
         if(state[i]==true)t=i;
         else {k=i;break;}
        }
     }
   if(k!=-1)// if there there has been changes
     {
      ObjectSetInteger(chart_id,name[k],OBJPROP_STATE,true); state[k]=true;
      ObjectSetInteger(chart_id,name[k],OBJPROP_BGCOLOR,Red);
      
      for(int i=0;i<s.progress_count;i++)
        {
         if(IsStopped())break;
         if(i<k)
           {
            ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
            state[i]=false;
            ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Tan);
           }
         if(i>k)
           {
            ObjectSetInteger(chart_id,name[i],OBJPROP_STATE,false);
            state[i]=false;
            ObjectSetInteger(chart_id,name[i],OBJPROP_BGCOLOR,Silver);
           }
        }
      return(k);
     }
   else return(t);// otherwise
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class Start/Stop                                                 |
//+------------------------------------------------------------------+
class CPlay
  {
private:
   long              chart_id;
   string            name_control;
   string            name_on_balance;
   string            name_all_balance;
   string            name_ind;
   int               handle;
   ushort            custom_event_id_All;   // identifier of the event of changing the balance to All
   ushort            custom_event_id_Sym;   // identifier of the event of changing the balance to Sym
   long              lparam;                // the long parameter
   double            dparam;                // the double parameter
   string            sparam;                // the string parameter
   bool              state1;                // ---
   bool              state2;                // flags of controlling the indicator
   bool              prev_state;            // ---
   bool              ind_state;             // ---
   ENUM_TIMEFRAMES   prev_period;
   int               ind_total;

   SBase            *s;
   CChartData       *d;
   void              IndicatorDelete(int ind_total);
   void              EventIndicators(bool &prev_state);
   void              StateIndicators();
   void              Ind_Balance_Create();
public:
   bool              state;
                     CPlay()
     {
      state=0;
      name_ind="Ind Balance";
      custom_event_id_All=10203;   // identifier of the event of changing the balance to All
      custom_event_id_Sym=10204;   // identifier of the event of changing the balance to Sym
      lparam=0;                    // the long parameter
      dparam=0.;                   // the double parameter
      sparam="";                   // the string parameter
      state1=0;
      state2=0;
      prev_state=1;
      ind_state=0;
     };
                    ~CPlay()
     {
      ObjectDelete(chart_id,name_control);
      ObjectDelete(chart_id,name_on_balance);
      ObjectDelete(chart_id,name_all_balance);
      // delete the indicator 
      state1=true;
      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      IndicatorDelete(ind_total);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update();
   void              Set_Play(bool play){ObjectSetInteger(chart_id,name_control,OBJPROP_STATE,play);}
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CPlay::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   lparam=chart_id; // assign id for passing to the indicator through a message
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   prev_period=d.period;
   string play,pause;
   name_control="the control button "+ChartSymbol(chart_id);

   if(ObjectFind(chart_id,name_control)<0)// if there's no object yet
     {//--- try to create the object 
      play="Images_Player\\Button_Play.bmp";
      pause="Images_Player\\Button_Pause.bmp";
      if(ObjectCreate(chart_id,name_control,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_control,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_control,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties
         ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_control,OBJPROP_YDISTANCE,s.YDISTANCE);
         //--- load an image for the "pressed" state of the button         
         ObjectSetString(chart_id,name_control,OBJPROP_BMPFILE,1,play);
         //--- load an image for the the "unpressed" state of the button
         ObjectSetString(chart_id,name_control,OBJPROP_BMPFILE,0,pause);
         Update();
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_control+". Error code ",GetLastError());
         ResetLastError();
        }
     }

   name_all_balance="the all_balance button "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_all_balance)<0)// if there's no object yet
     {
      play="Images_Player\\buttton_balance_all.bmp";
      pause="Images_Player\\buttton_balance_sym.bmp";
      //--- try to create the object         
      if(ObjectCreate(chart_id,name_all_balance,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_STATE,false);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_all_balance,OBJPROP_YDISTANCE,s.YDISTANCE-1);
         //--- load an image for the "pressed" state of the button         
         ObjectSetString(chart_id,name_all_balance,OBJPROP_BMPFILE,1,play);
         //--- load an image for the the "unpressed" state of the button
         ObjectSetString(chart_id,name_all_balance,OBJPROP_BMPFILE,0,pause);

        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_all_balance+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   name_on_balance="the on_balance button "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_on_balance)<0)// if there is no object yet
     {
      play="Images_Player\\buttton_balance_off.bmp";
      pause="Images_Player\\buttton_balance_on.bmp";
      //--- try to create the object         
      if(ObjectCreate(chart_id,name_on_balance,OBJ_BITMAP_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_STATE,false);

         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_on_balance,OBJPROP_YDISTANCE,s.YDISTANCE-1);

         //--- load an image for the "pressed" state of the button         
         ObjectSetString(chart_id,name_on_balance,OBJPROP_BMPFILE,1,play);
         //--- load an image for the the "unpressed" state of the button
         ObjectSetString(chart_id,name_on_balance,OBJPROP_BMPFILE,0,pause);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_on_balance+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CPlay::Update()
  {
   long temp=d.width_in_pixels/2;// checking and setting the X position of the button
   ObjectSetInteger(chart_id,name_control,OBJPROP_XDISTANCE,temp-26);
   ObjectSetInteger(chart_id,name_all_balance,OBJPROP_XDISTANCE,temp-161);
   ObjectSetInteger(chart_id,name_on_balance,OBJPROP_XDISTANCE,temp-199);
   dparam=(double)s.win_ind;
   if(s.state)// checking the button state
     {
      s.play=(bool)ObjectGetInteger(chart_id,name_control,OBJPROP_STATE);
      ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,0);
     }
   else // copying the state if the button is invisible
     {
      ObjectSetInteger(chart_id,name_control,OBJPROP_STATE,s.play);
      ObjectSetInteger(chart_id,name_control,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_all_balance,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_on_balance,OBJPROP_BACK,1);
     }
   if(s.flag_data)
     {
      //--- control of the balance indicator
      state2=(bool)ObjectGetInteger(chart_id,name_all_balance,OBJPROP_STATE);
      state1=(bool)ObjectGetInteger(chart_id,name_on_balance,OBJPROP_STATE);
      if(prev_period!=d.period)
        {
         // if the TF is changed
         ind_state=false;
         // delete the indicator
         ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
         IndicatorDelete(ind_total);

         prev_period=d.period;
        }
      StateIndicators();// add/remove the indicator
      //---
      EventIndicators(prev_state);// message to the indicators

      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      if((ind_total>1 && state1) || (ind_total>0 && !state1))
        {
         // delete the indicator
         IndicatorDelete(ind_total);
        }
     }
//--- 
  };
//+------------------------------------------------------------------+
//| status of the indicator                                          |
//+------------------------------------------------------------------+
void CPlay::StateIndicators()
  {
   if(state1 && !ind_state)
     {
      // add indicator
      Ind_Balance_Create();// adding the indicator of balance
      ind_state=true;
      //--- 
      double temp_arr[];
      int copy_size=CopyBuffer(handle,0,0,10,temp_arr);
      if(copy_size==10)// if the data is ready for working send the message
        {
         ushort custom_event=10205; sparam="10205";
         EventChartCustom(chart_id,custom_event,lparam,dparam,sparam);
         //Print("custom_event >>");
         prev_state=!prev_state;
         EventIndicators(prev_state);// send the message to the indicator
        }
     }
   if(!state1 && ind_state)
     {
      // delete the indicator      
      ind_total=ChartIndicatorsTotal(chart_id,s.win_ind);
      IndicatorDelete(ind_total);
      ind_state=false;
     }
  }
//+------------------------------------------------------------------+
//| sending message to the indicator                                 |
//+------------------------------------------------------------------+
void CPlay::EventIndicators(bool &prev_state)
  {
   if(!state2 && prev_state)
     {
      // the All message
      sparam="10203 All";
      EventChartCustom(chart_id,custom_event_id_All,lparam,dparam,sparam);
      prev_state=false;
     }
   if(state2 && !prev_state)
     {
      // the Sym message
      sparam="10204 Sym";
      EventChartCustom(chart_id,custom_event_id_Sym,lparam,dparam,sparam);
      prev_state=true;
     }
  }
//+------------------------------------------------------------------+
//| deletion of the indicator                                        |
//+------------------------------------------------------------------+
void CPlay::IndicatorDelete(int ind_total)
  {
// delete the indicator
   int total_wind=(int)ChartGetInteger(chart_id,CHART_WINDOWS_TOTAL);
   for(int j=0;j<total_wind;j++)
     {
      int beg_ind=0;
      if(ind_total>1 && state1)beg_ind=1;
      if(ind_total>0 && !state1)beg_ind=0;

      for(int i=beg_ind;i<ind_total;i++)
        {
         string short_name=ChartIndicatorName(chart_id,j,i);
         if(StringFind(short_name,name_ind,0)!=-1)
           {
            ChartIndicatorDelete(chart_id,j,short_name);
            s.win_ind=-1;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| add the indicator to the chart of the object                     |
//+------------------------------------------------------------------+
void CPlay::Ind_Balance_Create()
  {
   int total_wind=(int)ChartGetInteger(chart_id,CHART_WINDOWS_TOTAL)-1;
   MqlParam params[]; int count_params=ArrayResize(params,1);
   params[0].type          =TYPE_STRING;
   params[0].string_value  ="Player History Trades\\"+name_ind;

   handle=IndicatorCreate(ChartSymbol(chart_id),ChartPeriod(chart_id),IND_CUSTOM,count_params,params);

   if(ChartIndicatorAdd(chart_id,s.win_ind,handle))
     { s.win_ind=total_wind+1;}
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class of emulation of the event chart activation                 |
//+------------------------------------------------------------------+
class CClick
  {
private:
   long              chart_id;
   string            name;
   SBase            *s;
   CChartData       *d;
public:
   bool              state;
                     CClick(){state=0;};
                    ~CClick(){ObjectDelete(chart_id,name);};
   void              Create(long Chart_id,SBase *base,CChartData *data);
   bool              Update();
   bool              Event()
     {
      bool res=(bool)ObjectGetInteger(chart_id,name,OBJPROP_STATE);
      if(res){ObjectSetInteger(chart_id,name,OBJPROP_STATE,false); s.state=true; return(true);}
      else {return(false);}
     };
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CClick::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   name="the click button "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name,OBJ_BUTTON,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name,OBJPROP_BACK,1);
         ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name,OBJPROP_STATE,false);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties
         Update();
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
bool CClick::Update()
  {
   ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
//--- check the status and change the anchor corner (if required)
   bool res=Event();
   if(s.state)
     {
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,d.width_in_pixels*2);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,d.height_in_pixels*2);
     }
   else
     {
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,-10);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,-10);
     }
//--- check the size of button  
   ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,d.width_in_pixels*2);
   ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,d.height_in_pixels*2);

   return(res);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class of managing the rectangle that closes the future           |
//+------------------------------------------------------------------+
class CBackGround
  {
private:
   long              chart_id;
   string            name;
   SBase            *s;
   CChartData       *d;
   color             Color;
public:
   bool              state;
                     CBackGround(){state=0;};
                    ~CBackGround(){ObjectDelete(chart_id,name);};
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update(int bar_navigate);
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CBackGround::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   name="the BackGround field"+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//--- now set up the object properties 
         ObjectSetInteger(chart_id,name,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name,OBJPROP_COLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,0);
         Color=d.bgcolor;
         Update(0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CBackGround::Update(int bar_navigate)
  {
   int schift_size_pips;
   if(d.mode<2)schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.5)*d.pointer_per_bar)-1;
   else schift_size_pips=(int)((d.first_visible_bar-bar_navigate)*d.pointer_per_bar)-1;
   if(Color!=d.bgcolor)
     {
      Color=d.bgcolor;
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,d.bgcolor);
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,d.bgcolor);
     }
//--- send message to the indicator  
   ushort custom_event=10205; double dparam=(double)s.win_ind; string sparam="10205 BackGround";
   EventChartCustom(chart_id,custom_event,chart_id,dparam,sparam);

   ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,schift_size_pips);
   ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,schift_size_pips*2);
   ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,d.height_in_pixels);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class of drawing of the zero bar                                 |
//+------------------------------------------------------------------+
class CBarDraw
  {
private:
   long              chart_id;
   string            name_V;
   string            name_bid;
   string            name_bar_shadow;
   string            name_bar_candle;
   string            name_bar_candle_back;
   SBase            *s;
   CChartData       *d;
   string            symbol;
   int               digits;
   datetime          temp_m1[];
public:
   datetime          timeM1;
   double            open;
   double            high;
   double            low;
   double            close;
                     CBarDraw(){open=0;high=0;low=0;close=0;};
                    ~CBarDraw()
     {
      ObjectDelete(chart_id,name_V);
      ObjectDelete(chart_id,name_bid);
      ObjectDelete(chart_id,name_bar_shadow);
      ObjectDelete(chart_id,name_bar_candle);
     };
   void              Create(long Chart_id,SBase *base,CChartData *data);
   void              Update(int bar_navigate,
                            datetime time_bar,
                            datetime time_prev,
                            double close_prev,
                            double o,
                            double h,
                            double l,
                            double c
                            );
   void              Comments(double o,double h,double l,double c);
   void              Comments(string text=""){ChartSetString(chart_id,CHART_COMMENT,text);};
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CBarDraw::Create(long Chart_id,SBase *base,CChartData *data)
  {
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure
   symbol=ChartSymbol(chart_id);
   digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   name_V="V "+symbol;
   if(ObjectFind(chart_id,name_V)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_V,OBJ_VLINE,0,0,0,0,0))
        {//---
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_V+". Error code ",GetLastError());
         ResetLastError();
        }
     }

   name_bar_candle_back="candle back "+symbol;
   if(ObjectFind(chart_id,name_bar_candle_back)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_bar_candle_back,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties      
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,0);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_bar_candle_back+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   name_bar_shadow="shadow "+symbol;
   if(ObjectFind(chart_id,name_bar_shadow)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_bar_shadow,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,1);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_bar_shadow+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   name_bar_candle="candle "+symbol;
   if(ObjectFind(chart_id,name_bar_candle)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_bar_candle,OBJ_RECTANGLE_LABEL,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bgcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.linecolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         //--- bind the button to the upper right corner of the chart
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         //--- now set up the object properties      
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,0);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_bar_candle+". Error code ",GetLastError());
         ResetLastError();
        }
     }

   name_bid="bid "+symbol;
   if(ObjectFind(chart_id,name_bid)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_bid,OBJ_HLINE,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_bid,OBJPROP_COLOR,d.bidcolor);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_bid+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CBarDraw::Update(int bar_navigate,
                      datetime time_bar,
                      datetime time_prev,
                      double close_prev,
                      double o,
                      double h,
                      double l,
                      double c
                      )
  {
   ObjectSetInteger(chart_id,name_V,OBJPROP_TIME,timeM1);
   ObjectSetDouble(chart_id,name_bid,OBJPROP_PRICE,c);
   ObjectSetInteger(chart_id,name_bid,OBJPROP_COLOR,d.bidcolor);

   if(d.mode==0)// 
     {
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,0);
      //--- Body ----------------------          
      //--- calculate the width of bar   
      int width_of_bar=((int)d.pointer_per_bar*3/4+1)/2;
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,width_of_bar+1);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,width_of_bar+1);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.625)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips+width_of_bar);

      int O= WindowGetY(chart_id,o);
      int C= WindowGetY(chart_id,c);
      int scl=3-(d.scale/4);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,scl);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,O);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,scl);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,C);
      if(o>c)
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.downcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.downcolor);
        }
      else
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.upcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.upcolor);
        }

      //--- Shadow ---------------------- 
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,d.scale/4+1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_bar);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,h);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,l);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

   if(d.mode==1)// candlesticks
     {
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,1);
      //--- Body ----------------------          
      //--- calculate the width of bar   
      int width_of_bar=(int)d.pointer_per_bar*3/4+1;
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,width_of_bar);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,width_of_bar);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+0.625)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips);

      int O= WindowGetY(chart_id,o);
      int C= WindowGetY(chart_id,c);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,(int)fabs(O-C)+3);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,fmin(O,C));
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,(int)fabs(O-C)+3);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,fmin(O,C));
      if(o>c)
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.downcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bearcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.downcolor);
        }
      else
        {
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_COLOR,d.upcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BGCOLOR,d.bullcolor);
         ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_COLOR,d.upcolor);
        }

      //--- Shadow ---------------------- 
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_bar);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,h);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,l);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

   if(d.mode==2)// line
     {
      //--- remove unnecessary object
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_BACK,1);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_BACK,1);

      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_YDISTANCE,0);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_YDISTANCE,0);

      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XSIZE,2);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XSIZE,2);
      int schift_size_pips=(int)((d.first_visible_bar-bar_navigate+2)*d.pointer_per_bar-1);
      ObjectSetInteger(chart_id,name_bar_candle,OBJPROP_XDISTANCE,schift_size_pips);
      ObjectSetInteger(chart_id,name_bar_candle_back,OBJPROP_XDISTANCE,schift_size_pips);

      //--- line
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_WIDTH,d.scale/4+1);

      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,0,time_prev);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_TIME,1,time_bar);

      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,0,close_prev);
      ObjectSetDouble(chart_id,name_bar_shadow,OBJPROP_PRICE,1,c);
      ObjectSetInteger(chart_id,name_bar_shadow,OBJPROP_COLOR,d.linecolor);
     }

  };
//+------------------------------------------------------------------+
//| display information pane, symbol, TF, zero bar information,      |
//| period of generation                                             |
//+------------------------------------------------------------------+
void CBarDraw::Comments(double o,double h,double l,double c)
  {
   string EnumString=EnumToString(d.period);
   StringReplace(EnumString,"PERIOD_","");
   string EnumStringGen=EnumToString(s.period_gen);
   StringReplace(EnumStringGen,"PERIOD_","");
   string _OHLC_=" "+DoubleToString(o,digits)+" "+DoubleToString(h,digits)+
                 " "+DoubleToString(l,digits)+" "+DoubleToString(c,digits)
                 +"     period generator "+EnumStringGen;
   ChartSetString(chart_id,CHART_COMMENT,symbol+","+EnumString+_OHLC_);
  };
//+******************************************************************+
//+******************************************************************+
//+------------------------------------------------------------------+
//| Class of managing the redrawing of trade history                 |
//+------------------------------------------------------------------+
class CHistoryDraw
  {
private:
   long              chart_id;
   string            name_text; // name of volumes
   string            name_V;    // name of deal
   string            name_Tr;   // name of position
   string            name_out;  // name of out 
   string            name0,name1,name2,name3;
   color             COLOR;
   datetime          time0,time1,end_pos_time;
   double            price0,price1;
   int               font_size_vol;
   int               font_size_out;
   SBase            *s;
   CChartData       *d;
   CTable           *table;        // table of deal history
   int               pos;
public:
   bool              state;

                     CHistoryDraw()
     {
      font_size_vol=8;
      font_size_out=10;
      state=0;pos=0;
      end_pos_time=0;
     };
                    ~CHistoryDraw()
     {// clean before leaving
      if(ObjectFind(chart_id,name_text)>=0)
         ObjectDelete(chart_id,name_text);
      if(ObjectFind(chart_id,name_V)>=0)
         ObjectDelete(chart_id,name_V);
      if(ObjectFind(chart_id,name_Tr)>=0)
         ObjectDelete(chart_id,name_Tr);
      if(ObjectFind(chart_id,name_out)>=0)
         ObjectDelete(chart_id,name_out);
     };
   void              Create(CTable *table_,long Chart_id,SBase *base,CChartData *data);
   void              Update(datetime time,double level);
   void              FixingLast(int pos);// fixing the objects of deal
   void              RelevantPos(datetime time,double level,int pos);// the deal is being drawn
   void              NameObject(int pos); // full names of 4 objects
   string            NameObjectSwitch(int index);// names of objects without indexes
   void              DataObject(string name_color,string name_price);
   string            IndexObject(int pos);// returns two-value idnex of of objects "[79][8]" 
                                          //[79]-number of position [8]- number of deal in position
/*
   declared previously in Parser_Tester.mqh 
   void              TextVol(long chart_id,string name,color COLOR,int font_size,string text,datetime time,double price);
   void              TrendLine(long chart_id,string name,color COLOR,datetime time0,datetime time1,double price0,double price1);
   void              TrendVLine(long chart_id,string name,color COLOR,datetime time0,double price0,double price1);
*/
  };
//+------------------------------------------------------------------+
//| additional constructor with parameters                           |
//+------------------------------------------------------------------+
void CHistoryDraw::Create(CTable *table_,long Chart_id,SBase *base,CChartData *data)
  {
// time, type, direction, volume, price, deal result, balance, positionNo, No of deal in position
//   0     1      2        3      4        5         6        7           8  
   table=table_; if(table.SecondSize()>0){state=true; table.Get(0,table.SecondSize()-1,end_pos_time);}
   chart_id=Chart_id;
   s=base; // binding data to the player structure
   d=data; // binding data to the player structure

   name_text="HistoryDraw text_ "+ChartSymbol(chart_id); // name of volumes
   name_V="HistoryDraw V_ "+ChartSymbol(chart_id);       // name of deal
   name_Tr  ="HistoryDraw Tr_ "+ChartSymbol(chart_id);     // name of position
   name_out ="HistoryDraw out_ "+ ChartSymbol(chart_id);   // name of out 

   if(ObjectFind(chart_id,name_text)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_text,OBJ_TEXT,0,0,0))
        {//--- 
         ObjectSetInteger(chart_id,name_text,OBJPROP_BACK,0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_text+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_V)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_V,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_V,OBJPROP_BACK,0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_V+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_Tr)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_Tr,OBJ_TREND,0,0,0,0,0))
        {//---
         ObjectSetInteger(chart_id,name_Tr,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_Tr,OBJPROP_COLOR,d.bgcolor);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_Tr+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   if(ObjectFind(chart_id,name_out)<0)// if there's no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name_out,OBJ_TEXT,0,0,0))
        {//--- 
         ObjectSetInteger(chart_id,name_out,OBJPROP_BACK,0);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name_out+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  };
//+------------------------------------------------------------------+
//| refresh data                                                     |
//+------------------------------------------------------------------+
void CHistoryDraw::Update(datetime time,double level)
  {
   if(table.SecondSize()>0)// if the table is completely filled
     {
      int prev_pos=pos;
      datetime time_pos=0,time_pos1=0; table.Get(0,pos,time_pos);
      if(pos<table.SecondSize()-1) {table.Get(0,pos+1,time_pos1);}
      //---
      if(pos>1)FixingLast(1);
      if(time<end_pos_time)
        {
         if(time_pos<=time && time_pos1>time)
           {// if the number of deal hasn't changed
            RelevantPos(time,level,pos);
           }
         else
           {// 

            bool flag=false;
            for(int j=pos;j<table.SecondSize()-1;j++)
              {
               table.Get(0,j,time_pos);
               table.Get(0,j+1,time_pos1);
               if(time_pos<=time && time_pos1>time){pos=j;flag=true;break;}
              }
            // if the deal number has changed to a bigger one, skip this block  
            if(!flag)
              {// if the deal number has changed to a smaller one
               for(int j=1;j<pos;j++)
                 {
                  table.Get(0,j,time_pos);
                  table.Get(0,j+1,time_pos1);
                  if(time_pos<=time && time_pos1>time){pos=j;break;}
                 }
              }
            FixingLast(prev_pos);// fixing the previous deal  
            RelevantPos(time,level,pos);
           }
        }
      else
        {
         FixingLast(prev_pos);// fixing the previous deal
         pos=table.SecondSize()-1;
         FixingLast(pos);// fixing the previous deal  
        }
     }
  }
//+------------------------------------------------------------------+
//|   ,          |
//+------------------------------------------------------------------+  
void CHistoryDraw::FixingLast(int prev_pos)
  {
   NameObject(prev_pos);
   DataObject(name0,name2);
//   
//---  2
   ObjectSetInteger(chart_id,name2,OBJPROP_COLOR,COLOR);
   ObjectSetInteger(chart_id,name2,OBJPROP_BACK,0);
//---  3
   if(ObjectFind(chart_id,name3)>=0)
     {
      ObjectSetInteger(chart_id,name3,OBJPROP_TIME,time1);
      ObjectSetDouble(chart_id,name3,OBJPROP_PRICE,price1);
     }
   sp.TrendLine(chart_id,name_Tr,COLOR,0,0,0,0);
   sp.TrendVLine(chart_id,name_V,COLOR,0,0,0);
   sp.TextVol(chart_id,name_text,COLOR,"0",0,0);
  }
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
void CHistoryDraw::RelevantPos(datetime time,double level,int pos)
  {
   NameObject(pos);
   DataObject(name0,name2);
//     
   if(ObjectFind(chart_id,name1)>=0)
     {
      //---  2
      ObjectSetInteger(chart_id,name2,OBJPROP_COLOR,d.bgcolor);
      ObjectSetInteger(chart_id,name2,OBJPROP_BACK,1);
      //---  3
      if(ObjectFind(chart_id,name3)>=0)
        {
         ObjectSetInteger(chart_id,name3,OBJPROP_TIME,0);
         ObjectSetDouble(chart_id,name3,OBJPROP_PRICE,0);
        }
      //   
      if(time>=time0)
        {
         sp.TrendLine(chart_id,name_Tr,COLOR,time0,time,price0,level);
         sp.TrendVLine(chart_id,name_V,COLOR,time0,price0,price1);
        }
      if(pos>=0)
        {
         string text=ObjectGetString(chart_id,name0,OBJPROP_TEXT);
         sp.TextVol(chart_id,name_text,COLOR,text,time0,price0);
        }
     }
   else
     {
      sp.TextVol(chart_id,name_out,COLOR,"out",time1,price1);
      if(pos>=0)
        {
         NameObject(pos-1);
         DataObject(name0,name2);
         sp.TrendLine(chart_id,name_Tr,COLOR,time0,time1,price0,price1);
        }
     }
  }
//+------------------------------------------------------------------+
//|    .                           |
//+------------------------------------------------------------------+
void CHistoryDraw::DataObject(string name_color,string name_price)
  {
   COLOR=(color)ObjectGetInteger(chart_id,name_color,OBJPROP_COLOR);
//---
   time0=(datetime)ObjectGetInteger(chart_id,name_price,OBJPROP_TIME,0);
   time1=(datetime)ObjectGetInteger(chart_id,name_price,OBJPROP_TIME,1);
//---
   price0=ObjectGetDouble(chart_id,name_price,OBJPROP_PRICE,0);
   price1=ObjectGetDouble(chart_id,name_price,OBJPROP_PRICE,1);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void CHistoryDraw::NameObject(int pos)
  {
   string temp=IndexObject(pos);
   name0=NameObjectSwitch(0)+temp;//    
   name1=NameObjectSwitch(1)+temp;//    
   name2=NameObjectSwitch(2)+temp;//    
   name3=NameObjectSwitch(3)+temp;//      
  }
//+------------------------------------------------------------------+
//|   .                    |
//+------------------------------------------------------------------+
string CHistoryDraw::NameObjectSwitch(int index)//    
  {
   switch(index)
     {
      case  0: return("Text ");     break;
      case  1: return("TrLineV ");  break;
      case  2: return("TrLine ");   break;
      case  3: return("Text out "); break;
      default: return("");          break;
     }
  }
//+------------------------------------------------------------------+
//|   [][]               |
//+------------------------------------------------------------------+
string CHistoryDraw::IndexObject(int pos)
  {
   long Npos,Ndeal;
   table.Get(7,pos,Npos);
   table.Get(8,pos,Ndeal);
   return("["+(string)Npos+"]["+(string)Ndeal+"]");
  }
//+******************************************************************+
