//+------------------------------------------------------------------+
//|                                          Draft Player exp v5.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"

//--- skip the calculation if the chart is deleted
#define __LAST_ERR_CHART_WRONG_ID_void__  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();return;}ResetLastError();
#define __LAST_ERR_CHART_WRONG_ID__  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();return(0);}ResetLastError();
#define __LAST_ERR_CHART_WRONG_ID(chart_id)  ChartGetInteger(chart_id,CHART_MODE);if(GetLastError()==ERR_CHART_WRONG_ID){ResetLastError();continue;}ResetLastError();
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input string report="";                     // name of a html file of the tester report
input string Symbols="";                    // list of required charts
input bool   end_delet_charts=true;         // delete charts when deleting EA
input datetime beg_time=-1;                 // start of history
input datetime end_time=-1;                 // end of history
//+------------------------------------------------------------------+
input ENUM_TIMEFRAMES Period_Gen=PERIOD_M5; // period of the generator
input string fond_comment="Arial Narrow";   // font of the comments to deals
input int    fond_size=8;                   // font size of the comments to deals
input color  ColorBuy =clrBlue;             // color of buy positions
input color  ColorSell=clrRed;              // color of sell positions
input int    SPEED_LIMIT=5;                 // number of speeds
input int    Size_button_prog=8;            // vert. size of the progress button
//+------------------------------------------------------------------+
//| Include files                                                    |
//+------------------------------------------------------------------+
//| "Include\\Player5.mqh"                                           |
//|     "Player5_1.mqh"                                              |
//|         "Parser_Tester.mqh"                                      |
//|             "Decode MarketWatch.mqh"                             |
//|             "HTML.mqh"                                           |
//|             "Table.mqh"                                          |
//|         "Balance.mqh"                                            |
//|             <Arrays\ArrayLong.mqh>                               |
//|         "Ruler.mqh"                                              |
//+------------------------------------------------------------------+ 
#include "Include\\Player5.mqh" 
//+------------------------------------------------------------------+
//|******************************************************************|
//+------------------------------------------------------------------+

string Symbol_buf[];      // array of symbols selected by user
int totals;               // number of controlled charts
long arrayID[];           // array of chart IDs
CPlayer player[];         // array of objects for controlling charts
string trade_symbols[];   // list of symbols used for trading
datetime Time=0;          // the time of player is stored here
long Chart_ID;            // ID of the cart where the EA is launched
int nn;                   // index number of the active chart
int timer=60;             // frequency of timer
datetime begtime_,endtime_; // start and end date of testing
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
// set necessary properties of the chart for further copying
   Chart_ID=ChartID();
   ChartSetInteger(Chart_ID,CHART_AUTOSCROLL,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_ASK_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_BID_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_LAST_LINE,false);
   ChartSetInteger(Chart_ID,CHART_SHOW_OHLC,false);
   CChartData bases; bases.Update(ChartID());
// pass input parameters directly to the object
   sp.g.fond_comments=fond_comment;
   sp.g.font_sizes=fond_size;
   sp.g.colorBuy  =ColorBuy;
   sp.g.colorSell =ColorSell;
   Comment("OnInit   Parsing of trade history");
   CParser_Tester *pars=new CParser_Tester();
   pars.ParserOnStart(report);

   if(beg_time<0)begtime_=pars.begtime; else begtime_=beg_time;
   if(end_time<0)endtime_=pars.endtime; else endtime_=end_time;
//--- expand the range on 1 bar in both directions
   datetime null_time=TimeBars(0,_Symbol,_Period);
   int beg_=Bars(_Symbol,_Period,null_time,begtime_)+1;
   int end_=Bars(_Symbol,_Period,null_time,endtime_)-3;
   begtime_=TimeBars(beg_,_Symbol,_Period);
   endtime_=TimeBars(end_,_Symbol,_Period);
   Comment("OnInit   Creating balance history");
   ArrayCopy(trade_symbols,pars.trade_symbol);// save the symbol used for trading
   Balance_Process(report,pars.trade_symbol);// calculate the balance history   
   DebugBreak();
//--- normalization to the upper case
   string temp_sym=Symbols;
   if(temp_sym!="")StringToUpper(temp_sym);
//--- make the selection of required symbols
   for(int i=0;i<pars.dec.symbol_total;i++)
     {
      if(StringFind(temp_sym,pars.dec.symbol[i])!=-1)
        {
         int size=ArraySize(Symbol_buf);
         ArrayResize(Symbol_buf,size+1);
         Symbol_buf[size]=pars.dec.symbol[i];
        }
     }
   if(ArraySize(Symbol_buf)==0)// if symbols are not set
      ArrayCopy(Symbol_buf,trade_symbols);// copy the symbols used for trading

   Time=begtime_;// save the initial value of time
//---
   totals=ArraySize(Symbol_buf);

   Comment("OnInit   Opening required charts");
   ChartTotal(arrayID);// get the list of charts before opening additional ones
   for(int i=0;i<totals;i++)
     {
      ChartOpen(Symbol_buf[i],bases.period); // open the chart
      Sleep(100);
     }
   CurrentChart(arrayID);// get the list of charts for working

//--- create control objects
   totals=ArraySize(arrayID);
   ArrayResize(player,totals);
   ArrayResize(table,totals);

   Comment("OnInit   Loading control panels");
   for(int i=0;i<totals;i++)
     {
      Comment("OnInit   Loading the control panel "+ChartSymbol(arrayID[i]));
      //--- draw trade history on charts
      pars.HistoryDrawOnProcess(GetPointer(table[i]),arrayID[i]);
      //--- create control object
      player[i].Create(GetPointer(table[i]),
                       arrayID[i],
                       GetPointer(bases),
                       begtime_,
                       endtime_,
                       Period_Gen,
                       SPEED_LIMIT,
                       end_delet_charts,
                       Size_button_prog
                       );
     }     
   delete pars;// now we can delete the CParser_Tester object
   
//---
   nn=totals-1;
   player[nn].sb.state=true;// set the last opened chart as the active one   
   player[nn].Update();
   Comment(" Starting the player, you can hide this chart.");
//---  

   EventSetTimer(timer);
   OnTimer();
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   EventKillTimer();
   string name_file;
   int total=ArraySize(trade_symbols);
   if(end_delet_charts)// if the file for saving is not set
     {// delete the Excel files
      for(int i=0;i<total;i++)
        {
         name_file=report+" "+trade_symbols[i]+".csv";
         FileDelete(name_file);
        }
      name_file=report+" "+"All balance "+".csv";
      FileDelete(name_file);
     }
// delete binary files
   for(int i=0;i<total;i++)
     {
      name_file=trade_symbols[i]+" sym.dat";
      FileDelete(name_file);
     }
   name_file="All sym.dat";
   FileDelete(name_file);
   Comment("");
   ObjectsDeleteAll(Chart_ID,0);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   uint sleep=20;// delay time
   uint start=GetTickCount();
   while(!IsStopped() && start+timer*1000-(sleep+5)>=GetTickCount())
     {
      nn=Click(nn);                  // search for the active chart 
      Time=player[nn].Progress(Time);// check user actions, move time      
      CopyPlayer(nn);                // copy the player settings according to the template      
      Play(Time);                    // draw zero bar and trade history, update charts
      Sleep(sleep);                  // delay
     }
  }
//+------------------------------------------------------------------+
//| Searching for active chart                                       |
//+------------------------------------------------------------------+
int Click(int N)
  {
   int ntemp=N;
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(player[i].chart_id)
      if(player[i].EventClick()){ntemp=i;break;}
     }
   player[ntemp].Update();
   return(ntemp);
  }
//+------------------------------------------------------------------+
//| Copying the player settings according to the template            |
//+------------------------------------------------------------------+
void CopyPlayer(int N)
  {
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(Chart_ID)
      if(i!=N)
         player[i].Copy(GetPointer(player[N]));
     }
  }
//+------------------------------------------------------------------+
//| Drawing zero bar and trade history                               |
//+------------------------------------------------------------------+
void Play(datetime time)
  {
   for(int i=0;i<totals;i++)
     {
      __LAST_ERR_CHART_WRONG_ID(Chart_ID)
      player[i].Draw(time);
      player[i].Navigate(time);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//| Searching for added charts                                       |
//+------------------------------------------------------------------+
void CurrentChart(long &chart_id[])
  {
   long CurrChart[],buf[];int size=0;
   ChartTotal(CurrChart);
   int total=ArraySize(CurrChart);
   int Total=ArraySize(chart_id);
   for(int i=0;i<total;i++)
     {
      bool flag=true;
      for(int j=0;j<Total;j++)
        {
         if(CurrChart[i]==chart_id[j])flag=false;
        }
      if(flag)
        {
         size=ArrayResize(buf,size+1);buf[size-1]=CurrChart[i];
        }
     }
   ArrayCopy(chart_id,buf);
   return;
  }
//+------------------------------------------------------------------+
//| Array of IDs of open charts                                      |
//+------------------------------------------------------------------+
void ChartTotal(long &ChartId[])
  {
   int size=0;// array size
//--- variables for chart identifiers
   long currChart=-1,prevChart=ChartFirst();
   size=ArrayResize(ChartId,1);ChartId[size-1]=prevChart;

   while(!IsStopped())// exit if break is pressed or if user executes command of deletion
     {
      currChart=ChartNext(prevChart); // get new chart on the basis of the previous one
      if(currChart<0) break;          // the end of chart list is reached
      size=ArrayResize(ChartId,size+1);ChartId[size-1]=currChart;
      prevChart=currChart;// memorize identifier of the current chart for ChartNext()      
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
