//+------------------------------------------------------------------+
//|                                            Report Parser MT4.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
#property script_show_inputs
// the parser selects deals by login
input long login_=0; // login
                     // include files
#include "Include\\HTML.mqh"
#include "Include\\Table.mqh"
#include "Include\\Structur_File.mqh"

ENUM_DATATYPE  TYPE[14]=// the array that sets the number and types of columns of the table
  {
   TYPE_LONG,     // 0  Deal 
   TYPE_LONG,     // 1  Login
   TYPE_STRING,   // 2  Name
   TYPE_DATETIME, // 3  Open Time
   TYPE_STRING,   // 4  Type
   TYPE_STRING,   // 5  Symbol
   TYPE_DOUBLE,   // 6  Volume
   TYPE_DOUBLE,   // 7  Open Price
   TYPE_DATETIME, // 8  Close Time
   TYPE_DOUBLE,   // 9  Close Price
   TYPE_DOUBLE,   // 10 Swap
   TYPE_DOUBLE,   // 11 Profit
   TYPE_LONG,     // 12 Pips
   TYPE_STRING    // 13 Comment
  };
//--- global declaration of pointers (the script is started once, thus there is no need to save memory)
CTable table,table1,table2;
CArrayTradesMT4 trades;
CArrayTradesMT4 trades2;
CDecodeMarketWatch dec;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   dec.Inits();// initialization of object of the CDecodeMarketWatch class
   string folder="Automated Trading Championship 2008 All Trades";
//---
   Print("start of reading");
   FileRead(folder);
// WriteWrite0(folder+"_orig");
//     
   table.SortTwoDimArray(1,0,table.SecondSize()-1,true);
   FileWrite1(folder);// printing all logins and names.

   if(login_>600000)// if a login is set
     {
      // search for the first deal by the selected login
      int beg=table.SearchFirst(1,login_,0,table.SecondSize()-1,true);
      // search for the last deal by the selected login
      int end=table.SearchLast(1,login_,0,table.SecondSize()-1,true);
      // copying the selection
      table1.CopyTable(GetPointer(table),beg,end);
      // sorting the selection by the time of order opening
      table1.SortTwoDimArray(0,0,table1.SecondSize()-1,true);
      // rearrangement of columns
      table1.Insert(10,11);
      table1.Insert(12,1);
      table1.Insert(13,1);
      // copying the selection
      table2.CopyTable(GetPointer(table1),0,1);
      // rearrangement of columns
      table2.Insert(13,1);
      table2.Insert(13,4);
      // cutting unused columns
      table2.PruningTable(10);
      // increasing length of the table twice, preparing to replace MT4 orders with MT5 deals
      table2.SecondResize(table1.SecondSize()*2);

      //--- replacing MT4 orders with MT5 deals
      int size=table1.SecondSize();
      for(int j=0;j<size;j++)
        {
         table2.Set(0,j,"-"+table1.sGet(0,j));
         table2.Set(1,j,table1.sGet(2,j));
         table2.Set(2,j,table1.sGet(3,j));
         table2.Set(3,j,table1.sGet(4,j));
         table2.Set(4,j,table1.sGet(1,j));
         table2.Set(5,j,table1.sGet(5,j));
         table2.Set(6,j,"0");
         table2.Set(7,j,"0");
         table2.Set(8,j,"0");
         table2.Set(9,j,"0");
        }
      int size2=table2.SecondSize();
      for(int j=size;j<size2;j++)
        {
         table2.Set(0,j,table1.sGet(0,j-size));
         table2.Set(1,j,table1.sGet(2,j-size)=="sell"?"buy":"sell");
         table2.Set(2,j,table1.sGet(3,j-size));
         table2.Set(3,j,table1.sGet(4,j-size));
         table2.Set(4,j,table1.sGet(6,j-size));
         table2.Set(5,j,table1.sGet(7,j-size));
         table2.Set(6,j,table1.sGet(8,j-size));
         table2.Set(8,j,table1.sGet(10,j-size));
        }

      table2.SortTwoDimArray(4,0,table2.SecondSize()-1,true);
      table2.Set(7,0,0.);
      table2.Set(9,0,0);
      for(int j=1;j<size2;j++)
        {
         double dtemp_prev; table2.Get(7,j-1,dtemp_prev);
         double dtemp; table2.Get(6,j,dtemp);
         table2.Set(7,j,dtemp_prev+dtemp);
         long itemp_prev; table2.Get(9,j-1,itemp_prev);
         long itemp; table2.Get(8,j,itemp);
         table2.Set(9,j,itemp_prev+itemp);
        }

      trades.Resize(size2);
      for(int j=0;j<size2;j++)
        {
         string stemp="";
         table2.Get(1,j,stemp); trades.arr[j].type(stemp);
         table2.Get(2,j,stemp); trades.arr[j].symbol=(ushort)StringToInteger(dec.CodeSymbol(stemp));
         table2.Get(3,j,trades.arr[j].volume);
         table2.Get(4,j,trades.arr[j].time);
         table2.Get(5,j,trades.arr[j].price);
        }
      for(int j=1;j<size2;j++)
        {
         datetime prev_time=trades.arr[j-1].time;
         if(prev_time==trades.arr[j].time)
           {
            int c=0;
            while(j+c<size2 && prev_time==trades.arr[j+c].time)c++;
            for(int i=0;i<c;i++)
               trades.arr[j+i].time=(datetime)((long)prev_time+(long)(i+1));
           }
        }
      //--- save information for controlling on a csv file
      string folder_login="Automated Trading Championship 2008 ";
      FileWrite2(folder_login+(string)login_);
      //--- print the code page of symbols for passing to the EA in the tester      
      dec.PrintFile("Player Report Symbol");
      //--- print the binary file for passing to the EA in the tester        
      trades.WriteBinFile("Player Report");
      //--- check the correctness of operation of the system of reading the binary file     
      //trades2.ReadBinFile("Player Report");      
      //FileWrite3(folder_login+"trades");
      Print("end of printing");
     }
   Comment("");
  }
//+------------------------------------------------------------------+
//| reading the general history of the championship 2008,            |
//| parsing line by line                                             |
//+------------------------------------------------------------------+
string FileRead(string folder)
  {
   CHTML h; string text[14];
   table.FirstResize(TYPE);
//--- set accuracy  
   table.StringDigits(6,2);
   table.StringDigits(7,4);
   table.StringDigits(9,4);
   table.StringDigits(10,2);
   table.StringDigits(11,2);

   table.SecondResize(1000);
   int han=FileOpen(folder+".html",FILE_READ|FILE_SHARE_READ|FILE_ANSI,"\n");
   if(han!=INVALID_HANDLE)
     {
      int c=0,fl=-1;bool fl_start=false;
      while(!IsStopped())
        {
         string temp=FileReadString(han);
         StringTrimLeft(temp);StringTrimRight(temp);
         //---
         fl=h.tr.Search(temp,0);
         if(fl!=-1)
           {
            if(fl_start)
              {
               int fld=1;
               string temp_text=h.tr.base.casket;
               c++;
               if(c%1000==0)
                  table.SecondResize(c+1000);
               for(int i=0;i<14;i++)
                 {
                  fld=h.td.Search(temp_text,fld-1);
                  if(fld==-1)break;
                  table.Set(i,c-1,h.td.base.casket);
                 }
               if(c%1000==0){Comment(c);ChartRedraw();}
              }
            fl_start=true;
           }
         //---         
         if(FileTell(han)>=FileSize(han))break;
        }
      table.SecondResize(c);
      FileClose(han);
      Print("number of lines read = ",c);
     }
   else Print("File open failed "+folder+".html, error",GetLastError());

   return("");
  }
//+------------------------------------------------------------------+
//| function for debugging of printing, not used directly            |
//+------------------------------------------------------------------+
void FileWrite0(string folder)
  {
   int han=FileOpen(folder+".csv",FILE_WRITE|FILE_SHARE_WRITE|FILE_CSV|FILE_ANSI,";");
   if(han!=INVALID_HANDLE)
     {
      int size=table.SecondSize();
      for(int j=0;j<size;j++)
        {
         FileWrite(han,
                   table.sGet(0,j),
                   table.sGet(1,j),
                   table.sGet(2,j),
                   table.sGet(3,j),
                   table.sGet(4,j),
                   table.sGet(5,j),
                   table.sGet(6,j),
                   table.sGet(7,j),
                   table.sGet(8,j),
                   table.sGet(9,j),
                   table.sGet(10,j),
                   table.sGet(11,j),
                   table.sGet(12,j),
                   table.sGet(13,j)
                   );
        }
      FileClose(han);
     }
   else Print("File open failed "+folder+".csv, error",GetLastError());
  }
//+------------------------------------------------------------------+
//| printing the selection of all logins and names of                |
//| participants of the championship 2008                            |
//+------------------------------------------------------------------+
void FileWrite1(string folder)
  {
   CTable table_plus;
   ENUM_DATATYPE  type[2];
   type[0]= TYPE_LONG;     // 0  Login
   type[1]= TYPE_STRING;   // 1  Name  
   table_plus.FirstResize(type);
   int c=1;
   table_plus.SecondResize(c);
   table_plus.Set(0,0,table.sGet(1,0));
   table_plus.Set(1,0,table.sGet(2,0));
   long login; table.Get(1,0,login);

   int size=table.SecondSize();
   for(int j=0;j<size;j++)
     {
      long temp_login; table.Get(1,j,temp_login);
      if(login!=temp_login)
        {
         login=temp_login;
         c++;
         table_plus.SecondResize(c);
         table_plus.Set(0,c-1,temp_login);
         table_plus.Set(1,c-1,table.sGet(2,j));
        }
     }

//---
   int han=FileOpen(folder+"_plus.csv",FILE_WRITE|FILE_SHARE_WRITE|FILE_CSV|FILE_ANSI,";");
   if(han!=INVALID_HANDLE)
     {
      int lsize=table_plus.SecondSize();
      for(int j=0;j<lsize;j++)
        {
         FileWrite(han,
                   table_plus.sGet(0,j),
                   table_plus.sGet(1,j)
                   );
        }
      FileClose(han);
     }
   else Print("File open failed "+folder+"_plus.csv, error",GetLastError());

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FileWrite2(string folder)
  {
   int han=FileOpen(folder+".csv",FILE_WRITE|FILE_SHARE_WRITE|FILE_CSV|FILE_ANSI,";");
   if(han!=INVALID_HANDLE)
     {
      int size=table2.SecondSize();
      for(int j=0;j<size;j++)
        {
         FileWrite(han,
                   table2.sGet(0,j),
                   table2.sGet(1,j),
                   table2.sGet(2,j),
                   table2.sGet(3,j),
                   table2.sGet(4,j),
                   table2.sGet(5,j),
                   table2.sGet(6,j),
                   table2.sGet(7,j),
                   table2.sGet(8,j),
                   table2.sGet(9,j)
                   );
        }
      FileClose(han);
     }
   else Print("File open failed "+folder+".csv, error",GetLastError());
  }
//+------------------------------------------------------------------+
//| function for debugging of printing, not used directly            |
//+------------------------------------------------------------------+
void FileWrite3(string folder)
  {
   int han=FileOpen(folder+".csv",FILE_WRITE|FILE_SHARE_WRITE|FILE_CSV|FILE_ANSI,";");
   if(han!=INVALID_HANDLE)
     {
      double start_price=trades2.arr[0].price;
      int size=trades2.size;
      for(int j=0;j<size;j++)
        {
         FileWrite(han,
                   trades2.arr[j].time,
                   trades2.arr[j].price-start_price,
                   trades2.arr[j].volume,
                   dec.DecodeSymbol(trades2.arr[j].symbol!=0?(string)trades2.arr[j].symbol:"00"),
                   trades2.arr[j].type()
                   );
        }
      FileClose(han);
     }
   else Print("File open failed "+folder+".csv, error",GetLastError());
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
